package org.jpedal.examples.contentextractor;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.*;
import java.util.HashMap;
import java.util.Map;
import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;
import javax.swing.*;
import javax.xml.parsers.*;
import org.apache.crimson.tree.XmlDocument;
import org.jpedal.PdfDecoder;
import org.jpedal.examples.simpleviewer.SimpleViewer;
import org.jpedal.examples.simpleviewer.gui.ThumbnailPanel;
import org.jpedal.examples.simpleviewer.utils.IconiseImage;
import org.jpedal.io.ObjectStore;
import org.jpedal.utils.LogWriter;
import org.jpedal.utils.TimeNow;
import org.jpedal.utils.repositories.*;
import org.w3c.dom.*;

public class ContentExtractor extends SimpleViewer
{
    public class ButtonPopup
        implements ActionListener
    {

        public void actionPerformed(ActionEvent actionevent)
        {
            thumbnails.resetHighlightedThumbnail(id);
            thumbnails.validate();
            BufferedImage bufferedimage = JAI.create("fileload", imagesStored.elementAt(id)).getAsBufferedImage();
            popupDisplay(bufferedimage, xmlStored.elementAt(id), textStored.elementAt(id), id + 1, false, true);
        }

        int id;
        JButton buttons[];

        public ButtonPopup(int i)
        {
            id = i;
        }
    }

    protected class Extractor_mouse_clicker extends org.jpedal.examples.simpleviewer.SimpleViewer.mouse_clicker
    {

        public void mousePressed(MouseEvent mouseevent)
        {
            if(currentRectangle == null)
            {
                super.mousePressed(mouseevent);
                drawingCursorBox = true;
            } else
            {
                int ai[] = updateXY(mouseevent);
                oldX = ai[0];
                oldY = ai[1];
            }
        }

        public void mouseReleased(MouseEvent mouseevent)
        {
            drawingCursorBox = false;
            old_m_x2 = -1;
            old_m_y2 = -1;
            updateCords(mouseevent);
            if(m_x1 > m_x2)
            {
                int i = m_x1;
                m_x1 = m_x2;
                m_x2 = i;
            }
            if(m_y1 < m_y2)
            {
                int j = m_y1;
                m_y1 = m_y2;
                m_y2 = j;
            }
	}
            
// JavaClassFileOutputException: get_constant: invalid tag

        protected Extractor_mouse_clicker()
        {
        }
    }

    protected class Extractor_mouse_mover extends org.jpedal.examples.simpleviewer.SimpleViewer.mouse_mover
    {

        public void mouseDragged(MouseEvent mouseevent)
        {
            if(currentRectangle == null || drawingCursorBox)
            {
		//               x.setDrawCrossHairs(true, boxContained, Color.white);
                super.mouseDragged(mouseevent);
                boxContained = -1;
                return;
            }
            int ai[] = updateXY(mouseevent);
            boxes = createNewRectangles(currentRectangle);
            if(boxContained == -1)
            {
                int i = 0;
                do
                {
                    if(i >= boxes.length)
                        break;
                    if(boxes[i].contains(oldX, oldY))
                    {
                        boxContained = i;
                        break;
                    }
                    i++;
                } while(true);
            }
            if(boxContained != -1 || dragAltering)
            {
                drawingCursorBox = false;
                int j = boxContained;
                int k = (int)boxes[boxContained].getCenterX();
                int l = (int)boxes[boxContained].getCenterY();
                if(currentRectangle.x == k)
                    m_x1 = ai[0];
                else
                if(currentRectangle.x + currentRectangle.width == k)
                    m_x2 = ai[0];
                if(currentRectangle.y == l)
                    m_y2 = ai[1];
                else
                if(currentRectangle.y + currentRectangle.height == l)
                    m_y1 = ai[1];
                boolean flag = false;
                boolean flag1 = false;
                if(m_x1 > m_x2)
                    flag = true;
                if(m_y2 > m_y1)
                    flag1 = true;
                if(flag || flag1)
                    switch(j)
                    {
                    default:
                        break;

                    case 0: // '\0'
                        if(flag)
                            j = 3;
                        break;

                    case 1: // '\001'
                        if(flag1)
                            j = 2;
                        break;

                    case 2: // '\002'
                        if(flag1)
                            j = 1;
                        break;

                    case 3: // '\003'
                        if(flag)
                            j = 0;
                        break;

                    case 4: // '\004'
                        if(flag)
                            j = 6;
                        else
                        if(flag1)
                            j = 5;
                        if(flag && flag1)
                            j = 7;
                        break;

                    case 5: // '\005'
                        if(flag)
                            j = 7;
                        else
                        if(flag1)
                            j = 4;
                        if(flag && flag1)
                            j = 6;
                        break;

                    case 6: // '\006'
                        if(flag)
                            j = 4;
                        else
                        if(flag1)
                            j = 7;
                        if(flag && flag1)
                            j = 5;
                        break;

                    case 7: // '\007'
                        if(flag)
                            j = 5;
                        else
                        if(flag1)
                            j = 6;
                        if(flag && flag1)
                            j = 4;
                        break;
                    }
		// x.setDrawCrossHairs(true, j, Color.white);
                scrollAndUpdateCoords(mouseevent);
                generateNewCursorBox();
                dragAltering = true;
                oldX = ai[0];
                oldY = ai[1];
            } else
            {
                drawingCursorBox = true;
                boxContained = -1;
                //x.setDrawCrossHairs(true, boxContained, Color.white);
                m_x1 = oldX;
                m_y1 = oldY;
                m_x2 = ai[0];
                m_y2 = ai[1];
                scrollAndUpdateCoords(mouseevent);
                generateNewCursorBox();
            }
        }

        public void mouseMoved(MouseEvent mouseevent)
        {
            super.mouseMoved(mouseevent);
            boxes = createNewRectangles(currentRectangle);
            if(boxes != null)
            {
                int i = boxContained;
                boxContained = -1;
                int j = 0;
                do
                {
                    if(j >= boxes.length)
                        break;
                    if(boxes[j].contains(cx, cy))
                    {
                        boxContained = j;
                        break;
                    }
                    j++;
                } while(true);
                if(boxContained != i)
                    handleChange = true;
            }
            if(currentRectangle != null)
                if(currentRectangle.x - handlesGap < cx && currentRectangle.x + currentRectangle.width + handlesGap > cx && currentRectangle.y - handlesGap < cy && currentRectangle.y + currentRectangle.height + handlesGap > cy)
                {
		    //  x.setDrawCrossHairs(true, boxContained, Color.white);
                    if(!inRect || handleChange)
                    {
			//  x.repaint();
                        handleChange = false;
                        inRect = true;
                    }
                } else
                {
		    // x.setDrawCrossHairs(false, boxContained, Color.white);
                    if(inRect || handleChange)
                    {
			// x.repaint();
                        handleChange = false;
                        inRect = false;
                    }
                }
        }

        private Rectangle[] createNewRectangles(Rectangle rectangle)
        {
            if(rectangle != null)
            {
                int i = rectangle.x;
                int j = rectangle.y;
                int k = i + rectangle.width;
                int l = j + rectangle.height;
                Rectangle arectangle[] = new Rectangle[8];
                arectangle[0] = new Rectangle(i - handlesGap, (j + Math.abs(l - j) / 2) - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[1] = new Rectangle((i + Math.abs(k - i) / 2) - handlesGap, j - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[2] = new Rectangle((i + Math.abs(k - i) / 2) - handlesGap, l - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[3] = new Rectangle(k - handlesGap, (j + Math.abs(l - j) / 2) - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[4] = new Rectangle(i - handlesGap, j - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[5] = new Rectangle(i - handlesGap, l - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[6] = new Rectangle(k - handlesGap, j - handlesGap, handlesGap * 2, handlesGap * 2);
                arectangle[7] = new Rectangle(k - handlesGap, l - handlesGap, handlesGap * 2, handlesGap * 2);
                return arectangle;
            } else
            {
                return null;
            }
        }

        private boolean inRect;
        private boolean handleChange;

        protected Extractor_mouse_mover()
        {
            inRect = false;
            handleChange = false;
        }
    }


    public ContentExtractor()
    {
        itemSelectedX1 = new Vector_Int(10);
        itemSelectedY1 = new Vector_Int(10);
        itemSelectedWidth = new Vector_Int(10);
        itemSelectedHeight = new Vector_Int(10);
        pageUsed = new Vector_Int(10);
        imagesStored = new Vector_String(10);
        thumbnailsStored = new Vector_Object(10);
        imagesUsed = new HashMap();
        textStored = new Vector_String(10);
        xmlStored = new Vector_String(10);
        itemSelectedCount = 1;
        showItemsExtracted = new JButton();
        saveItemsExtracted = new JButton();
        boxes = new Rectangle[8];
        handlesGap = 5;
        oldX = -1;
        oldY = -1;
        dragAltering = false;
        boxContained = -1;
        drawingCursorBox = false;
        showOutlines = false;
    }

    public static void main(String args[])
    {
        ContentExtractor contentextractor = new ContentExtractor();
        contentextractor.setupViewer();
    }

    public void setupViewer()
    {
        try
        {
            init(null);
            setupExtractorGUI();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
            System.out.println("Exception on initialisation");
        }
    }

    private void setupExtractorGUI()
    {
        titleMessage = "IDRsolutions Extraction Solution FRF-2.60b10 ";
        setViewerTitle(titleMessage);
        initGUIComponents();
        JPanel jpanel = new JPanel();
        jpanel.setLayout(new BorderLayout());
        getContentPane().add(jpanel, "North");
        decode_pdf.addMouseMotionListener(new Extractor_mouse_mover());
        decode_pdf.addMouseListener(new Extractor_mouse_clicker());
        JMenuBar jmenubar = new JMenuBar();
        jpanel.add(jmenubar, "North");
        createMenu(jmenubar, false);
        JToolBar jtoolbar = new JToolBar();
        jtoolbar.setBorder(BorderFactory.createEmptyBorder());
        jtoolbar.setLayout(new FlowLayout(3));
        jtoolbar.setFloatable(false);
        jtoolbar.setFont(new Font("SansSerif", 0, 8));
        jpanel.add(jtoolbar, "Center");
        JToolBar jtoolbar1 = new JToolBar();
        jtoolbar1.setBorder(BorderFactory.createEmptyBorder());
        jtoolbar1.setLayout(new FlowLayout(3));
        jtoolbar1.setFloatable(false);
        jtoolbar1.setFont(new Font("SansSerif", 0, 8));
        jpanel.add(jtoolbar1, "South");
        createExtractorButtons(jtoolbar);
        jtoolbar.add(Box.createHorizontalGlue());
        jtoolbar.add(Box.createHorizontalGlue());
        jtoolbar.add(Box.createHorizontalGlue());
        jtoolbar.add(Box.createHorizontalGlue());
        first.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        fback.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        back.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        forward.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        fforward.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        end.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        pageCounter2.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        end.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                createOnscreenOutlines();
            }

        });
        setNavToolVisible(false);
        createPageNavigation(jtoolbar);
        createPageSizingButtons(jtoolbar1);
        setupScreen();
    }

    private void setNavToolVisible(boolean flag)
    {
        first.setVisible(flag);
        fback.setVisible(flag);
        back.setVisible(flag);
        forward.setVisible(flag);
        fforward.setVisible(flag);
        end.setVisible(flag);
        pageCounter1.setVisible(flag);
        pageCounter2.setVisible(flag);
        pageCounter3.setVisible(flag);
    }

    private void createThumbnails()
    {
        navOptionsPanel.removeAll();
        thumbnails = new ThumbnailPanel();
        displayPane.setDividerLocation(divLocation);
        navOptionsPanel.add(thumbnails.setupThumbnails(itemSelectedCount - 1, pageUsed.get(), pageCount), "Extracted items");
        thumbnails.createThumbnailsFromImages(imagesStored.get(), thumbnailsStored);
        for(int i = 0; i < itemSelectedCount - 1; i++)
        {
            JButton jbutton = thumbnails.getButton(i);
            jbutton.addActionListener(new ButtonPopup(i));
        }

    }

    private void createExtractorButtons(JToolBar jtoolbar)
    { }
    /*        openButton(jtoolbar);
        jtoolbar.add(Box.createHorizontalGlue());
        JButton jbutton = new JButton();
        jbutton.setBorderPainted(false);
        ImageIcon imageicon = new ImageIcon(getClass().getResource("/org/jpedal/examples/contentextractor/snapgrid.gif"));
        jbutton.setIcon(imageicon);
        createPressedLook(jbutton, imageicon);
        jbutton.setToolTipText("Click to snap onto outlines");
        jtoolbar.add(jbutton);
        jbutton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                if(currentRectangle != null)
                    Rectangle rectangle = currentRectangle;
	    }
        });
        jtoolbar.add(Box.createHorizontalGlue());
        JButton jbutton1 = new JButton();
        jbutton1.setBorderPainted(false);
        ImageIcon imageicon1 = new ImageIcon(getClass().getResource("/org/jpedal/examples/simpleviewer/snapshot.gif"));
        jbutton1.setIcon(imageicon1);
        createPressedLook(jbutton1, imageicon1);
        jbutton1.setToolTipText("Click to extract selected rectangle");
        jtoolbar.add(jbutton1);
        jbutton1.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                if(ContentExtractor.this.ContentExtractor != null && !
// JavaClassFileOutputException: get_constant: invalid tag

        });
        jtoolbar.add(Box.createHorizontalGlue());
        jtoolbar.add(Box.createHorizontalGlue());
        showItemsExtracted.setBorderPainted(false);
        showItemsExtracted.setVisible(false);
        ImageIcon imageicon2 = new ImageIcon(getClass().getResource("/org/jpedal/examples/contentextractor/list.gif"));
        showItemsExtracted.setIcon(imageicon2);
        createPressedLook(showItemsExtracted, imageicon2);
        if(showExtractedItems)
            showItemsExtracted.setToolTipText("Hide extracted items");
        else
            showItemsExtracted.setToolTipText("Show extracted items");
        jtoolbar.add(showItemsExtracted);
        showItemsExtracted.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                boolean flag = !
// JavaClassFileOutputException: get_constant: invalid tag

        });
        jtoolbar.add(Box.createHorizontalGlue());
        saveItemsExtracted.setBorderPainted(false);
        saveItemsExtracted.setVisible(false);
        ImageIcon imageicon3 = new ImageIcon(getClass().getResource("/org/jpedal/examples/simpleviewer/save.gif"));
        saveItemsExtracted.setIcon(imageicon3);
        createPressedLook(saveItemsExtracted, imageicon3);
        saveItemsExtracted.setToolTipText("Save extracted items");
        jtoolbar.add(saveItemsExtracted);
        saveItemsExtracted.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                boolean flag = saveThumbnails();
                if(flag)
                    resetToEmpty(false);
            }

        });
        jtoolbar.add(Box.createHorizontalGlue());
    }
    */
    private boolean saveThumbnails()
    {
        boolean flag = false;
        JFileChooser jfilechooser = new JFileChooser(System.getProperty("user.dir"));
        jfilechooser.setFileSelectionMode(1);
        int i = jfilechooser.showSaveDialog(jfilechooser);
        if(i == 0)
        {
            File file = jfilechooser.getSelectedFile();
            String s = file.getAbsolutePath();
            if(file.exists())
            {
                JOptionPane.showMessageDialog(c, "Directory already exists - please use another name");
            } else
            {
                file.mkdirs();
                if(target != null)
                {
                    File file1 = new File(target);
                    String as[] = file1.list();
                    if(as != null)
                    {
                        for(int j = 0; j < as.length; j++)
                            if((!as[j].endsWith("TIFF")) | (imagesUsed.get(as[j]) != null))
                            {
                                File file2 = new File(target + separator + as[j]);
                                decode_pdf.getObjectStore();
                                ObjectStore.copy(target + separator + as[j], s + separator + as[j]);
                                file2.deleteOnExit();
                                file2.delete();
                            }

                    }
                    flag = true;
                }
            }
        }
        if(flag)
            removeThumbnails();
        return flag;
    }

    private void removeThumbnails()
    {
        navOptionsPanel.setVisible(false);
        showExtractedItems = false;
        navOptionsPanel.removeAll();
    }

    protected void openButton(JToolBar jtoolbar)
    {
        JButton jbutton = new JButton();
        ImageIcon imageicon = new ImageIcon(getClass().getResource("/org/jpedal/examples/simpleviewer/open.gif"));
        jbutton.setIcon(imageicon);
        createPressedLook(jbutton, imageicon);
        jbutton.setToolTipText(getMessage("PdfViewerTooltip.open"));
        jbutton.setBorderPainted(false);
        jtoolbar.add(jbutton);
        jbutton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
		{
		/*                if(_22_Extracted_20_Content_20_WILL_20_be_20_overwritten_22_ > 0)
                    JOptionPane.showMessageDialog(access$3700, getMessage("PdfViewerPrintWait.message"));
                else
                if(_22__20_ARE_20_YOU_20_SURE_20_you_20_wish_20_to_20_lose_20_the_20_currently_20_selected_20_items_3F__22_)
                {
                    JOptionPane.showMessageDialog(access$3700, getMessage("PdfViewerDecodeWait.message"));
                } else
                {
                    boolean flag = true;
                    if(itemSelectedCount == 1)
                    {
                        flag = false;
                    } else
                    {
                        int i = JOptionPane.showConfirmDialog(access$3700, " ARE YOU SURE you wish to lose the currently selected items?", "Extracted Content WILL be overwritten", 0);
                        if(i == 0)
                            flag = false;
                    }
                    if(!flag)
                    {
                        resetToEmpty(false);
                        selectFile();
                        if(message_22_ > 2)
                            setNavToolVisible(true);
                        else
                            setNavToolVisible(false);                    }
		    }*/
            }
        });
        jtoolbar.add(Box.createHorizontalGlue());
    }

    private void resetToEmpty(boolean flag)
    {
        if(flag && itemSelectedCount > 1)
        {
            int i = JOptionPane.showConfirmDialog(c, "Do you wish to save it first?", "Extracted Content WILL be overwritten", 0);
            if(i == 0)
                while(!saveThumbnails()) ;
        }
        showExtractedItems = false;
        displayPane.setDividerLocation(0);
        showItemsExtracted.setVisible(false);
        saveItemsExtracted.setVisible(false);
        itemSelectedX1 = new Vector_Int(10);
        itemSelectedY1 = new Vector_Int(10);
        itemSelectedWidth = new Vector_Int(10);
        itemSelectedHeight = new Vector_Int(10);
        itemSelectedCount = 1;
        pageUsed = new Vector_Int(10);
        imagesStored = new Vector_String(10);
        imagesUsed = new HashMap();
        thumbnailsStored = new Vector_Object(10);
        textStored = new Vector_String(10);
        xmlStored = new Vector_String(10);
        if(target != null)
            flush();
        decode_pdf.removeHiglightedObject();
        decode_pdf.setHighlightedZones(0, null, null, null, null, null, null, null, null, null);
        decode_pdf.updateCursorBoxOnScreen(null, null);
        decode_pdf.repaint();
    }

    private void extractContent()
    {
        BufferedImage bufferedimage = null;
        String s = null;
        String s1 = null;
        bufferedimage = extractSelectedScreenAsImage();
        popupDisplay(bufferedimage, s, s1, itemSelectedCount, true, false);
    }

    private void popupDisplay(BufferedImage bufferedimage, String s, String s1, int i, final boolean calculateLocations, boolean flag)
    {
        JTabbedPane jtabbedpane = new JTabbedPane();
        JPanel jpanel = new JPanel();
        jpanel.setLayout(new BorderLayout());
        if(bufferedimage != null)
            jpanel.add(new JLabel(new IconiseImage(bufferedimage)), "Center");
        else
            return;
        JScrollPane jscrollpane = new JScrollPane();
        jscrollpane.setVerticalScrollBarPolicy(20);
        jscrollpane.setHorizontalScrollBarPolicy(30);
        jscrollpane.getVerticalScrollBar().setUnitIncrement(80);
        jscrollpane.getHorizontalScrollBar().setUnitIncrement(80);
        jscrollpane.getViewport().add(jpanel);
        jscrollpane.setPreferredSize(new Dimension(400, 400));
        jtabbedpane.addTab("Image", jscrollpane);
        String s2 = "Extracted Content - would you like to accept?";
        if(flag)
            s2 = "Would you like to save any changes you have made to this item?";
        final JDialog displayFrame = new JDialog(this, true);
        displayFrame.setLocationRelativeTo(null);
        displayFrame.setLocation(getLocationOnScreen().x + 10, getLocationOnScreen().y + 10);
        displayFrame.setSize(450, 450);
        displayFrame.setTitle(s2);
        displayFrame.getContentPane().setLayout(new BorderLayout());
        displayFrame.getContentPane().add(jtabbedpane, "Center");
        JPanel jpanel1 = new JPanel();
        jpanel1.setLayout(new BorderLayout());
        displayFrame.getContentPane().add(jpanel1, "South");
        JButton jbutton = new JButton("YES");
        jbutton.setFont(new Font("SansSerif", 0, 12));
        jpanel1.add(jbutton, "West");
        jbutton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                if(itemSelectedCount == 1)
                {
                    showItemsExtracted.setVisible(true);
                    saveItemsExtracted.setVisible(true);
                }
                if(calculateLocations)
                {
                    itemSelectedCount++;
                    itemSelectedX1.addElement(m_x1);
                    itemSelectedY1.addElement(m_y1);
                    itemSelectedWidth.addElement(m_x2);
                    itemSelectedHeight.addElement(m_y2);
                }
                if(calculateLocations)
                    createOnscreenOutlines();
                displayFrame.dispose();
            }

        });
        JButton jbutton1 = new JButton("NO");
        jbutton1.setFont(new Font("SansSerif", 0, 12));
        jpanel1.add(jbutton1, "East");
        jbutton1.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent actionevent)
            {
                displayFrame.dispose();
            }

        });
        displayFrame.show();
    }

    private void createOnscreenOutlines()
    {
        int ai[] = itemSelectedX1.get();
        int ai1[] = itemSelectedY1.get();
        int ai2[] = itemSelectedWidth.get();
        int ai3[] = itemSelectedHeight.get();
        int ai4[] = new int[itemSelectedCount];
        boolean aflag[] = new boolean[itemSelectedCount];
        Rectangle2D arectangle2d[] = new Rectangle2D[itemSelectedCount];
        Shape ashape[] = new Shape[itemSelectedCount];
        Color acolor[] = new Color[itemSelectedCount];
        int ai5[] = new int[itemSelectedCount];
        int ai6[] = new int[itemSelectedCount];
        for(int i = 0; i < itemSelectedCount; i++)
        {
            ai4[i] = i;
            aflag[i] = true;
            arectangle2d[i] = new Rectangle(ai[i], ai3[i], ai2[i] - ai[i], ai1[i] - ai3[i]);
            ai5[i] = (int)((arectangle2d[i].getBounds().getMinX() + arectangle2d[i].getBounds().getMaxX()) / 2D);
            ai6[i] = (int)((arectangle2d[i].getBounds().getMinY() + arectangle2d[i].getBounds().getMaxY()) / 2D) - 12;
            if(pageUsed.elementAt(i) == currentPage)
                ashape[i] = arectangle2d[i];
            acolor[i] = Color.BLUE;
            currentRectangle = null;
            decode_pdf.setHighlightedZones(1, ai5, ai6, ashape, null, null, arectangle2d, aflag, acolor, ai4);
            decode_pdf.repaint();
        }

    }

    private void saveExtractedContent(BufferedImage bufferedimage, String s, String s1, int i, boolean flag)
    {
        if(target == null)
            try
            {
                File file = File.createTempFile("jpedal", "ads");
                File file1 = new File(file.getAbsolutePath() + "-files");
                file1.mkdirs();
                file1.deleteOnExit();
                target = file1.getAbsolutePath();
                file.delete();
            }
            catch(IOException ioexception)
            {
                ioexception.printStackTrace();
            }
        if(target != null)
        {
            if(flag)
                if(bufferedimage != null)
                {
                    String s2 = "page_" + currentPage + "_id" + i + "." + "TIFF";
                    String s3 = target + separator + s2;
                    JAI.create("filestore", bufferedimage, s3, "TIFF");
                    imagesStored.addElement(s3);
                    imagesUsed.put(s2, "x");
                } else
                {
                    imagesStored.addElement(null);
                    thumbnailsStored.addElement(null);
                }
        } else
        {
            JOptionPane.showMessageDialog(this, "Problem accessing drive - unable to save images");
        }
    }

    private void writeText(String s, String s1, int i, int j)
        throws Exception
    {
        OutputStreamWriter outputstreamwriter = new OutputStreamWriter(new FileOutputStream(s1 + separator + "page_" + j + "_id" + i + ".txt"));
        outputstreamwriter.write(s);
        outputstreamwriter.close();
    }

    public void writeXML(String s, String s1, int i, int j)
        throws Exception
    {
        try
        {
            XmlDocument xmldocument = new XmlDocument();
            Element element = xmldocument.createElement("content");
            xmldocument.appendChild(element);
            org.w3c.dom.Comment comment = xmldocument.createComment("Created " + TimeNow.getShortTimeNow());
            org.w3c.dom.Comment comment1 = xmldocument.createComment("Extracted via JPedal");
            org.w3c.dom.Comment comment2 = xmldocument.createComment("SourceFile " + decode_pdf.getObjectStore().getCurrentFilename());
            element.appendChild(comment);
            element.appendChild(comment1);
            element.appendChild(comment2);
            Element element1 = addTextAsXML(s, xmldocument, element);
            Node node = xmldocument.importNode(element1, true);
            element.appendChild(node);
            FileOutputStream fileoutputstream = new FileOutputStream(s1 + separator + "page_" + j + "_id" + i + ".xml");
            OutputStreamWriter outputstreamwriter = new OutputStreamWriter(fileoutputstream, "UTF8");
            xmldocument.write(outputstreamwriter);
            outputstreamwriter.flush();
            outputstreamwriter.close();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
    }

    private Element addTextAsXML(String s, XmlDocument xmldocument, Node node)
        throws FactoryConfigurationError
    {
        Element element = null;
        try
        {
            StringBuffer stringbuffer = new StringBuffer("<?xml version=\"1.0\" encoding=\"UTF-16\"?><text>");
            ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream();
            OutputStreamWriter outputstreamwriter = new OutputStreamWriter(bytearrayoutputstream, "UTF-8");
            outputstreamwriter.write("<?xml version=\"1.0\"?><text>");
            int i = s.length();
            for(int j = 0; j < i; j++)
            {
                char c = s.charAt(j);
                if(c == '&')
                {
                    boolean flag = false;
                    for(int k = j + 1; k < i; k++)
                    {
                        char c1 = s.charAt(j);
                        if(c1 == ';')
                        {
                            k = i;
                            flag = true;
                            continue;
                        }
                        if((c1 == ' ') | (c1 == '\n'))
                            k = i;
                    }

                    if(flag)
                        outputstreamwriter.write(c);
                    else
                        outputstreamwriter.write("&amp;");
                    continue;
                }
                if(c > 0)
                    outputstreamwriter.write(c);
            }

            outputstreamwriter.write("</text>");
            outputstreamwriter.close();
            bytearrayoutputstream.close();
            ByteArrayInputStream bytearrayinputstream = new ByteArrayInputStream(bytearrayoutputstream.toByteArray());
            DocumentBuilderFactory documentbuilderfactory = DocumentBuilderFactory.newInstance();
            Document document = documentbuilderfactory.newDocumentBuilder().parse(bytearrayinputstream);
            NodeList nodelist = document.getElementsByTagName("text");
            element = (Element)nodelist.item(0);
            bytearrayoutputstream.close();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
            LogWriter.writeLog("Exception " + exception + " in writing text \n" + s);
        }
        return element;
    }

    private BufferedImage extractSelectedScreenAsImage()
    {
        int i = m_x1;
        int j = m_x2;
        int k = m_y1;
        int l = m_y2;
        if(m_y1 < m_y2)
        {
            l = m_y1;
            k = m_y2;
        }
        if(m_x1 > m_x2)
        {
            j = m_x1;
            i = m_x2;
        }
        return decode_pdf.getSelectedRectangleOnscreen(i, k, j, l, 100);
    }

    private Vector_Int itemSelectedX1;
    private Vector_Int itemSelectedY1;
    private Vector_Int itemSelectedWidth;
    private Vector_Int itemSelectedHeight;
    private Vector_Int pageUsed;
    private Vector_String imagesStored;
    Vector_Object thumbnailsStored;
    private Map imagesUsed;
    private Vector_String textStored;
    private Vector_String xmlStored;
    private int itemSelectedCount;
    private boolean showExtractedItems;
    JButton showItemsExtracted;
    JButton saveItemsExtracted;
    private final String type = "TIFF";
    private Rectangle boxes[];
    private int handlesGap;
    private int oldX;
    private int oldY;
    private boolean dragAltering;
    private int boxContained;
    private boolean drawingCursorBox;


























































}
