/*
 * Helpeditor.java
 *
 * Created on April 22, 2004, 12:21 PM
 */

/**
 *
 * @author  smuelas
 */

import java.util.*;
import java.lang.String.*;
import java.io.*;
import java.net.URL;
import java.io.IOException;
import java.awt.*;
import java.awt.Color.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeSelectionModel;

public class Helpeditor extends javax.swing.JFrame {
    private boolean playWithLineStyle = false;
    private String lineStyle = "Angled"; 
    public static String welcome="file:./manual/bienvenida.html";
    BookInfo[] contador = new BookInfo[10];
    DefaultMutableTreeNode category;
    DefaultMutableTreeNode category2;
    DefaultMutableTreeNode category3;

    Color micolor = new Color(80,80,120);

    Font mifont = new Font("Sanserif",Font.PLAIN, 10);
    Font mibold = new Font("Sanserif",Font.BOLD, 10);
    Font miboldbig = new Font("Sanserif",Font.BOLD, 14);
    
    public Helpeditor() {
    UIManager.put("Tree.leafIcon", new ImageIcon("manual/world.png"));
    UIManager.put("Tree.openIcon", new ImageIcon("manual/door_open.png"));
    UIManager.put("Tree.closedIcon", new ImageIcon("manual/door_closed.png"));
    UIManager.put("Tree.expandedIcon", new ImageIcon("manual/unlocked.png"));
    UIManager.put("Tree.collapsedIcon", new ImageIcon("manual/locked.png"));
    initComponents();
    }
    
    private void initComponents() {
        DefaultMutableTreeNode top = new DefaultMutableTreeNode("Index");
        createNodes(top);
        jSplitPane1 = new javax.swing.JSplitPane();
        visor = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        tree = new javax.swing.JTree(top);
        tree.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        tree.setForeground(micolor);
	tree.setFont(mibold);
        tree.getSelectionModel().setSelectionMode
	    (TreeSelectionModel.SINGLE_TREE_SELECTION);
	
        //Listen for when the selection changes.
        tree.addTreeSelectionListener(new TreeSelectionListener() {
		public void valueChanged(TreeSelectionEvent e) {
		    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
			tree.getLastSelectedPathComponent();
	       		    if(node == null) return;
		    Object nodeInfo = node.getUserObject();
		    if (node.isLeaf()) {
			BookInfo item = (BookInfo)nodeInfo;
			displayURL(item.bookURL);
			for(int i=1; i<10; i++) contador[i-1] = contador[i];
			contador[9]=item;
		    }
		}
	    });
	
        if (playWithLineStyle) {
            tree.putClientProperty("JTree.lineStyle", lineStyle);
        }
	
	jPanel1.setLayout(new BorderLayout(2,2));
        jTabbedPane1 = new javax.swing.JTabbedPane();
	jTabbedPane1.setForeground(micolor);
        jScrollPane1 = new javax.swing.JScrollPane();
        jScrollPane0 = new javax.swing.JScrollPane();
	try {
	    visor = new JEditorPane(welcome);
	}
	catch (IOException ex) {
	    ex.printStackTrace(System.err);
	    System.exit(1);
	}
	visor.setEditable(false);
       	visor.addHyperlinkListener(new HyperlinkListener() {
		public void hyperlinkUpdate(HyperlinkEvent evu) {
		    try {
			if (evu.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			    visor.setPage(evu.getURL());
		    } 
		    catch (IOException ex) { ex.printStackTrace(System.err); }
		}
	    });
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        addWindowListener(new java.awt.event.WindowAdapter() {
		public void windowClosing(java.awt.event.WindowEvent evt) {
		    exitForm(evt);
		}
	    });
	
        jSplitPane1.setDividerLocation(250);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setMinimumSize(new java.awt.Dimension(930, 760));
        jSplitPane1.setPreferredSize(new java.awt.Dimension(932, 762));
        visor.setPreferredSize(new java.awt.Dimension(680, 760));
        jSplitPane1.setRightComponent(jScrollPane0);
        jPanel1.setPreferredSize(new java.awt.Dimension(250, 760));
        jTabbedPane1.setName("");
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(250, 760));
	jScrollPane1.setViewportView(tree);
        jScrollPane0.setViewportView(visor);
        jTabbedPane1.addTab("Items", jScrollPane1);
        jScrollPane2.setViewportView(jTextArea3);
        jScrollPane3.setViewportView(jTextArea4);
        jTabbedPane1.setSelectedIndex(0);
        jPanel1.add(jTabbedPane1);
        jSplitPane1.setLeftComponent(jPanel1);
        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);
        jMenu2.setText("");
        jMenuBar2.add(jMenu2);
        setJMenuBar(jMenuBar2);
        pack();
        initHelp();
    }
    
    private void exitForm(java.awt.event.WindowEvent evt) {
	this.setVisible(false);
    }
    
    private class BookInfo {
        public String bookName;
        public URL bookURL;
        public String prefix = "file:" 
	    + System.getProperty("user.dir")
	    + System.getProperty("file.separator");
        public BookInfo(String item, String filename) {
            bookName = item;
            try {
                bookURL = new URL(prefix + filename);
            } catch (java.net.MalformedURLException exc) {
                System.err.println("Intento de crear un BookInfo "
                                   + "con un URL erróneo: " + bookURL);
                bookURL = null;
            }
        }
	
        public String toString() {
            return bookName;
        }
    }
    
    private void initHelp() {
        String s = null;
        try {
            s = "file:" 
                + System.getProperty("user.dir")
                + System.getProperty("file.separator")
                + "bienvenida.html";
        } catch (Exception e) {
            System.err.println("No se ha podido lanzar el URL: " + s);
        }
    }
    
    private void displayURL(URL url) {
        try {
            visor.setPage(url);
        } 
	catch (IOException e) {
            System.err.println("Intento de leer un URL erróneo: " + url);
        }
    }
    
    private void createNodes(DefaultMutableTreeNode top) {
	category = new DefaultMutableTreeNode("Objets");
	category3 = new DefaultMutableTreeNode("Basic Metagraf");
        DefaultMutableTreeNode primero = null;
        DefaultMutableTreeNode primero_2 = null;
        DefaultMutableTreeNode segundo = null;
        DefaultMutableTreeNode tercero = null;
        DefaultMutableTreeNode item = null;
    
	primero = new DefaultMutableTreeNode("Generalities: The Menu");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Introduction","manual/general_0.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu-Bar","manual/general_1.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: File","manual/general_2.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Actions","manual/general_3.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Open Objects","manual/general_4.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Closed Objects","manual/general_5.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Standard Text","manual/general_6.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu Curved Text","manual/general_7.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Decoration","manual/general_8.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Special","manual/general_9.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Settings","manual/general_10.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Menu: Help","manual/general_11.html"));
        primero.add(item);

        item = new DefaultMutableTreeNode(new BookInfo
					  ("Rotaciones","manual/objetos_4.html"));
	primero_2 = new DefaultMutableTreeNode("Metagraf's Objets");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Introduction","manual/dra01.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Open Objects","manual/dra02.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Closed Objects","manual/dra03.html"));
        primero_2.add(item);



        segundo = new DefaultMutableTreeNode("Advanced Metagraf");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("The Viewer","manual/advan01.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Data window", "manual/advan02.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("The Arrow chooser", "manual/advan03.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Layers & stack","manual/advan04.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("False Objects","manual/advan05.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Selection problems","manual/advan06.html"));
        segundo.add(item);
		item = new DefaultMutableTreeNode(new BookInfo
					  ("Circles & spirals","manual/advan07.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Curved Lines","manual/advan08.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Closed Curves","manual/advan09.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Special items on Curves","manual/advan10.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Arcs","manual/advan11.html"));
        segundo.add(item);
	
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Curved Text","manual/advan12.html"));
        segundo.add(item);

	tercero = new DefaultMutableTreeNode("Basic Drawing");
        item = new DefaultMutableTreeNode(new BookInfo ("Introduction","manual/dra04.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("General HOWTO","manual/dra05.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Drawing a Line","manual/dra06.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Editing a Line","manual/dra07.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Rotating & Scaling","manual/dra08.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Precission transforms","manual/dra09.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Grouping objects","manual/dra10.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Tips & tricks","manual/dra11.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Using the Zoom","manual/dra12.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Writing Text","manual/dra13.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo ("Editing Text","manual/dra14.html"));
        tercero.add(item);




        category3.add(primero);
	category3.add(primero_2);
	category3.add(tercero);

	item = new DefaultMutableTreeNode(new BookInfo
					  ("Welcome","manual/bienvenida.html"));
	top.add(item);
	top.add(category3);
	top.add(segundo);


    }
    
    
      public static void main(String args[]) {
        new Helpeditor().show();
	}
    
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane0;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JEditorPane visor;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTree tree;
}
