import java.io.*;
import java.awt.*;
import java.util.*;
import java.awt.geom.* ;

//***********************************************************************

class Center extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 36888865359591521L;
    Color c;
    int x0,y0;
    double pxc,pyc;
    static Shape miShape;
    ArrayList<Point2D.Double> miArray = new ArrayList<Point2D.Double>();

    Center(int x,int y,ArrayList p)
	{
	    super(p);
	    x0 = xmin = xmax = x;
	    y0 = ymin = ymax = y;
	    miArray.add(new Point2D.Double((double)x0,(double)y0));
	    pxc=(double)x;
	    pyc=(double)y;
	    select=0;
	}
   
    Center(double x,double y,ArrayList<Objetos> p)
	{
	    super(p);
	    x0=(int)x; y0=(int)y;
	    pxc=x;
	    pyc=y;
	    xmin=(int)pxc-2; xmax=(int)pxc+2;
	    ymin=(int)pyc-2; ymax=(int)pyc+2;
	    select=0;
	}

    public void paint(Graphics g)
    {
	Graphics2D g2 = (Graphics2D)g;
	float strokeThickness = 0.5f;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	x0=(int)pxc; y0=(int)pyc;
	GeneralPath miPunto = new GeneralPath();
	miPunto.moveTo((float)x0-1,(float)y0-1);
	miPunto.lineTo((float)x0+1f,(float)y0+1f);
	miShape = (Shape)miPunto;
	if(select==0)g2.setColor(Color.blue);
	else if(select==1)g2.setColor(Color.red);
        g2.fillRect(x0-1,y0-1,3,3);
	g2.drawLine(x0,y0-9,x0,y0+9);
	g2.drawLine(x0-9,y0,x0+9,y0);
    }

    public Shape getShape(){
	return(miShape);
    }

    public Object clone() {
	Objetos ob;
	try {
	    ob=(Objetos)super.clone();
	    miArray=(ArrayList)miArray.clone();
	} 
	catch(Exception e) {System.out.println("No clonado!!");return(null);}
	return (Object)ob;
    }

    public void moveobj(int x,int y) {
	x0 += x; pxc += (double)x;
	y0 += y; pyc += (double)y;
	xmin=x0-5; ymin=y0-5;
	xmax=x0+5; ymax=y0+5;
    }

    public void movepoint(int x,int y) {
	x0 += x; pxc += (double)x;
	y0 += y; pyc += (double)y;
	xmin=x0-5; ymin=y0-5;
	xmax=x0+5; ymax=y0+5;
    }

    public boolean selectpoint(int x,int y)
	{
	    if(((x+5*Drawing.u)>x0 && (x-5*Drawing.u)<x0) && ((y+5*Drawing.u)>y0 && (y-5*Drawing.u)<y0)) 
	    {
		select = 1;
		return(true);
	    }  
	    return(false);
	}

    public boolean selectobj(int x,int y)
	{
	    if(((x+5*Drawing.u)>x0 && (x-5*Drawing.u)<x0) && ((y+5*Drawing.u)>y0 && (y-5*Drawing.u)<y0))
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
	{
	    if(xx0<x0 && xx1>x0 && yy0<y0 && yy1>y0)
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}

}
