import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.awt.Color.*;
import java.awt.Dimension.*;
import java.awt.geom.*;
import java.awt.datatransfer.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.UIManager.*;

public class Editor extends JFrame implements ActionListener, Constants
{
String directorio, file;
JScrollPane miScroll;
JTextArea texto;
Color lightYellow = new Color(255,255,235);
BufferedWriter escribe;
  
public static void main(String[] args){
    new Editor();
}

public Editor () {
this(null, null); 
}
public Editor(String file) {
this(null, file);
} 
 
public Editor(String directorio, String file) {
super("Metagraf's Editor");
texto = new JTextArea("", 25, 40);
texto.setFont(new Font("SansSerif", Font.PLAIN, 14));
texto.setEditable(true);
miScroll = new JScrollPane(texto);
getContentPane().add("Center", miScroll);
JPanel p = new JPanel(); 
p.setBackground(lightYellow);
p.setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 5));
getContentPane().add(p, "South");
Font font = new Font("SansSerif", Font.BOLD, 12);
JButton open = new JButton("Open");
open.addActionListener(this);
open.setIcon(openicon);
open.setBorder(borFin);
open.setFont(font);
JButton save = new JButton("Save");
save.addActionListener(this);
save.setIcon(saveicon);
save.setBorder(borFin);
save.setFont(font);
JButton close = new JButton("Close");
close.addActionListener(this);
close.setIcon(closeicon);
close.setBorder(borFin);
close.setFont(font);
p.add(open);
p.add(save);
p.add(close);
this.pack();
setFile(directorio, file);
setVisible(true);
}

public void setLookAndFeel(String look)
{
try
{
String aspect = UIManager.getSystemLookAndFeelClassName();
UIManager.setLookAndFeel(aspect);
SwingUtilities.updateComponentTreeUI(this);
validate();
}
catch(Exception e) {
System.out.println("No se pudo cambiar el look n feel: " + e.getMessage());
}
}

public void setFile(String directorio, String file) {
if((file==null) || (file.length()==0)) return;
File f;
FileReader in = null;
try {
f=new File(directorio, file);
in=new FileReader(f);
char[] buffer=new char[4096];
int len;
texto.setText("");
while((len = in.read(buffer)) != -1) {
String s = new String(buffer, 0, len);
texto.append(s);
}
this.setTitle("Editor: "+file);
texto.setCaretPosition(0);
}
catch (IOException e) {
texto.setText(e.getClass().getName()+": "+e.getMessage());
this.setTitle("Editor: "+file+": I/O Exception");
}

finally { try { if(in!=null) in.close(); } catch(IOException ey3) {} }
}

public void saveFile(String directorio, String file) {
File f;
FileWriter out = null;
try {
f=new File(directorio, file);
out=new FileWriter(f);
escribe=new BufferedWriter(out);
escribe.write(texto.getText());
escribe.close();
}
catch (IOException ey4) {  }
}

public void actionPerformed(ActionEvent e) {
String cmd = e.getActionCommand();
if(cmd=="Open") {
    JFrame miframe = new JFrame();
    miframe.setBackground(lightYellow);
FileDialog f = new FileDialog(miframe,"Open File", FileDialog.LOAD);
f.setDirectory(directorio);
f.show();
directorio=f.getDirectory();
file = f.getFile();
if(cmd=="Open")setFile(directorio,file);
f.dispose();
}
else if(cmd=="Save") saveFile(directorio,file);
//else if(cmd.equals("Close"))setVisible(false);
else if(cmd.equals("Close"))System.exit(0);
}
}

