import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import org.jpedal.PdfDecoder;

public class JPanelDemo extends JFrame {

    private String viewerTitle="Metagraf Viewer";
    private PdfDecoder pdfDecoder;
    private String currentFile="mgraf.pdf";
    private int currentPage=1;
    public JPanelDemo(String name){
	pdfDecoder = new PdfDecoder();
	setTitle(viewerTitle);
	currentFile = name;
	if(currentFile!=null){
	    try{
		pdfDecoder.openPdfFile(currentFile);
		pdfDecoder.decodePage(currentPage);
		pdfDecoder.setPageParameters(1,1);
		}
	    catch(Exception e){e.printStackTrace();}
	}
	initializeViewer();
    }

    synchronized public void view() {
	Thread runner1 = new Thread() 
	{
	public void run() 
	{
	    try 
		{
		    pdfDecoder.openPdfFile(currentFile);
		    pdfDecoder.decodePage(currentPage);
		    pdfDecoder.setPageParameters(1,1);
		}
	catch (Exception e9) {}
		}
	    };
	runner1.start();
	repaint();
    }

	private void initializeViewer() {
	    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	    Container cPane = getContentPane();
	    cPane.setLayout(new BorderLayout());
	    JScrollPane display = initPDFDisplay();
	    cPane.add(display,BorderLayout.CENTER);
	    pack();
	    Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
	    setSize(new Dimension(412,745));
	    //	    setVisible(true);
	}
 
	private JScrollPane initPDFDisplay() {
		
		JScrollPane currentScroll = new JScrollPane();
		currentScroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		currentScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		
		currentScroll.setViewportView(pdfDecoder);
        
		return currentScroll;
	}
}
