/*
 * Mg2.java
 *
 * Created on August 5, 2005, 9:28 PM
 */

import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
/**
 *
 * @author  Santiago Muelas
 */

public class Mg2 extends JFrame implements Constants, Data, MySubject, ActionListener
{
    private static final long serialVersionUID = 1L;
    private JMenuBar menuBar = new JMenuBar();
    protected static JToolBar toolBar = new JToolBar();
    protected static JToolBar toolBar2 = new JToolBar(JToolBar.VERTICAL);
    private JSlider slider = new JSlider();
    private ArrayList observers;
    static String orden;

    public Mg2(String title, Metagraf miMeta) {
	observers = new ArrayList();
	setTitle(title);
	this.miMeta = miMeta;
	String myFilename = "Images/mg3icon16.gif";
	Image myImage = new ImageIcon(myFilename).getImage();
	setIconImage(myImage);
	setJMenuBar(menuBar);
	menuBar.setBorder(BorderFactory.createRaisedBevelBorder());
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

	JMenu fileMenu = new JMenu("File");
	JMenu actionsMenu = new JMenu("Actions");
	JMenu objectsMenu = new JMenu("Objects");
	JMenu openedMenu = new JMenu("Open-Lines");
	JMenu closedMenu = new JMenu("Closed-Shapes");
	JMenu textMenu = new JMenu("Text");
	JMenu standardMenu = new JMenu("Standard");
	JMenu curvedMenu = new JMenu("Curved");
	JMenu decorMenu = new JMenu("Decor");
	JMenu specialMenu = new JMenu("Special");
	JMenu settingsMenu = new JMenu("Settings");
	JMenu toolbarMenu = new JMenu("Toolbars");
	JMenu gridMenu = new JMenu("Grid");
	JMenu justifyMenu = new JMenu("Text justify");
	JMenu helpMenu = new JMenu("Help");
	JMenu transformMenu = new JMenu("Transform");
	JMenu positionMenu = new JMenu("Mode");
	JMenu circleMenu = new JMenu("Circle");

	open = new MyAction("Open");
	save = new MyAction("Save");
	paste = new MyAction("Paste");
	view = new MyAction("Viewer");
	exit = new MyAction("Exit");

	addMenuItem(fileMenu, open);
	addMenuItem(fileMenu, paste);
	addMenuItem(fileMenu, save);
	addMenuItem(fileMenu, view);
	addMenuItem(fileMenu, exit);


	addMenuItem(actionsMenu, delete = new MyAction("Delete"));
	addMenuItem(actionsMenu, newa = new MyAction("Clear"));
	addMenuItem(actionsMenu, group = new MyAction("Group"));
	addMenuItem(actionsMenu, group_all = new MyAction("Group_all"));
	addMenuItem(actionsMenu, ungroup = new MyAction("Ungroup"));
	addMenuItem(actionsMenu, ungroup_all = new MyAction("Ungroup_all"));
	addMenuItem(actionsMenu, select_all = new MyAction("Select_all"));
	addMenuItem(actionsMenu, clone = new MyAction("Clone"));


	objectsMenu.add(openedMenu);
	objectsMenu.add(closedMenu);

	addMenuItem(openedMenu, point = new MyAction("Point"));
	addMenuItem(openedMenu, line = new MyAction("Line"));
	addMenuItem(openedMenu, polyline = new MyAction("Polyline"));
	addMenuItem(openedMenu, bezier = new MyAction("Bezier"));
	addMenuItem(openedMenu, bspline = new MyAction("Bspline"));
	addMenuItem(openedMenu, nurb = new MyAction("Nurb"));
	addMenuItem(openedMenu, spiral = new MyAction("Spiral"));
	addMenuItem(openedMenu, angle = new MyAction("Angle"));

	addMenuItem(closedMenu, rectangle = new MyAction("Rectangle"));
	addMenuItem(closedMenu, roundrectangle = new MyAction("Roundrectangle"));
	addMenuItem(closedMenu, ellipse = new MyAction("Ellipse"));
	addMenuItem(closedMenu, polygon = new MyAction("Polygon"));
	addMenuItem(closedMenu, polyreg = new MyAction("RegPolygon"));
	addMenuItem(closedMenu, sector = new MyAction("Sector"));
	addMenuItem(closedMenu, arco = new MyAction("Arch"));
	addMenuItem(closedMenu, normalcircle = new MyAction("Circle"));
	addMenuItem(closedMenu, closbezier = new MyAction("CloseBezier"));
	addMenuItem(closedMenu, closspline = new MyAction("CloseSpline"));
	addMenuItem(closedMenu, closednurb = new MyAction("ClosedNurb"));

	textMenu.add(standardMenu);
	addMenuItem(textMenu, curved = new MyAction("CurvedTxt",null , "Create curved text "));

	addMenuItem(standardMenu, place = new MyAction("PlaceTxt",null , "Place the text where the first-click is produced"));
	addMenuItem(standardMenu, font = new MyAction("Font", null, "Opens window to choose special font"));
	addMenuItem(standardMenu, scale = new MyAction("Scale", null, "To choose the size of the text"));
	addMenuItem(standardMenu, center = new MyAction("Center", null, "Puts the center of the text-string in the point of the first-click "));
	addMenuItem(standardMenu, right = new MyAction("Right", null, "Puts the text to the right of the first-click "));
	addMenuItem(standardMenu, left = new MyAction("Left", null, "Puts the text to the left of the first-click "));

	addMenuItem(decorMenu, myarrow = new MyAction("PlaceArrow"));
	addMenuItem(decorMenu, color = new MyAction("Color"));
	addMenuItem(decorMenu, fillcolor = new MyAction("Fillcolor"));
	addMenuItem(decorMenu, unfill = new MyAction("Unfill"));
	addMenuItem(decorMenu, thickness = new MyAction("Thickness"));
	addMenuItem(decorMenu, stroke = new MyAction("Stroke"));
	addMenuItem(decorMenu, lincap = new MyAction("Lincap"));
	addMenuItem(decorMenu, linjoin = new MyAction("Linjoin"));

	addMenuItem(specialMenu, editor = new MyAction("Editor"));
	addMenuItem(specialMenu, metapost = new MyAction("Metapost"));
	addMenuItem(specialMenu, image = new MyAction("Image"));
	addMenuItem(specialMenu, placeImag = new MyAction("PlaceImag"));
	addMenuItem(specialMenu, latex = new MyAction("Latex"));
	addMenuItem(specialMenu, dvips = new MyAction("Dvips"));

	addMenuItem(settingsMenu, arrows = new MyAction("SetArrow"));
	settingsMenu.add(toolbarMenu);
	addMenuItem(toolbarMenu, showTB = new MyAction("Show"));
	addMenuItem(toolbarMenu, hideTB = new MyAction("Hide"));
	settingsMenu.add(gridMenu);
	addMenuItem(gridMenu, no = new MyAction("Nothing"));
	addMenuItem(gridMenu, verysmall = new MyAction("VerySmall"));
	addMenuItem(gridMenu, small = new MyAction("Small"));
	addMenuItem(gridMenu, medium = new MyAction("Medium"));
	addMenuItem(gridMenu, big = new MyAction("Big"));

	settingsMenu.add(justifyMenu);
	addMenuItem(justifyMenu, center = new MyAction("Center", null, "Puts the center of the text-string in the point of the first-click "));
	addMenuItem(justifyMenu, right = new MyAction("Right", null, "Puts the text to the right of the first-click "));
	addMenuItem(justifyMenu, left = new MyAction("Left", null, "Puts the text to the left of the first-click "));

	settingsMenu.add(transformMenu);
	addMenuItem(transformMenu, yescenter = new MyAction("PlaceCenter", null, "Size of the screen corresponding to A5."));
	addMenuItem(transformMenu, nocenter = new MyAction("RemoveCenter", null, "Size of the screen corresponding to A4."));
	addMenuItem(transformMenu, nozoom = new MyAction("NoZoom", null, "Size of the screen corresponding to A3."));

	addMenuItem(helpMenu, manual = new MyAction("Manual"));
	addMenuItem(helpMenu, keyboard = new MyAction("Keyboard", null, "Show the list of direc instructions through the keyboard"));
	addMenuItem(helpMenu, about = new MyAction("About"));
	addMenuItem(helpMenu, contact = new MyAction("Contact"));

	menuBar.add(fileMenu);
	menuBar.add(actionsMenu);
	menuBar.add(objectsMenu);
	menuBar.add(textMenu);
	menuBar.add(decorMenu);
	menuBar.add(specialMenu);
	menuBar.add(settingsMenu);
	menuBar.add(helpMenu);

	openB = newbutton(openicon,"Open");
	pasteB = newbutton(pasteicon,"Paste");
	saveB = newbutton(saveicon,"Save");
	viewB = newbutton(viewicon,"Viewer");
	clearB = newbutton(clearicon,"Clear");
	deleteB = newbutton(deleteicon,"Delete");
	exitB = newbutton(exiticon,"Exit");
	groupB = newbutton(groupicon,"Group");
	ungroupB = newbutton(ungroupicon,"Ungroup");
	group_allB = newbutton(group_allicon,"Group_all");
	ungroup_allB = newbutton(ungroup_allicon,"Ungroup_all");
	select_allB = newbutton(selecticon,"Select_all");
	cloneB = newbutton(cloneicon,"Clone");
	pointB = newbutton(pointicon,"Point");
	lineB = newbutton(lineicon,"Line");
	rectangleB = newbutton(rectangleicon,"Rectangle");
	circleB = newbutton(circleicon,"Circle");
	polylineB = newbutton(polylineicon,"Polyline");
	bezierB = newbutton(beziericon,"Bezier");
	bsplineB = newbutton(bsplineicon,"Bspline");
	nurbB = newbutton(nurbicon,"Nurb");
	spiralB = newbutton(spiralicon,"Spiral");
	angleB = newbutton(angleicon,"Angle");
	roundrectangleB = newbutton(roundrectangleicon,"Roundrectangle");
	ellipseB = newbutton(ellipseicon,"Ellipse");
	polygonB = newbutton(polygonicon,"Polygon");
	polyregB = newbutton(polyregicon,"RegPolygon");
	placeB = newbutton(placeicon,"PlaceTxt");
	sectorB = newbutton(sectoricon,"Sector");
	arcoB = newbutton(arcoicon,"Arch");
	closebezierB = newbutton(closebeziericon,"CloseBezier");
	closesplineB = newbutton(closesplineicon,"CloseSpline");
	closednurbB = newbutton(closednurbicon,"ClosedNurb");
	scaleB = newbutton(scaleicon,"Scale");
	fontB = newbutton(fonticon,"Font");
	centerB = newbutton(centericon,"Center");
	rightB = newbutton(righticon,"Right");
	leftB = newbutton(lefticon,"Left");
	colorB = newbutton(coloricon,"Color");
	fillcolorB = newbutton(fillcoloricon,"Fillcolor");
	unfillB = newbutton(unfillicon,"Unfill");
	arrowsB = newbutton(arrowsicon,"PlaceArrow");
	thicknessB = newbutton(thicknessicon,"Thickness");
	strokeB = newbutton(strokeicon,"Stroke");
	editorB = newbutton(editoricon,"Editor");
	metapostB = newbutton(metaposticon,"Metapost");
	imageB = newbutton(imageicon,"Image");
	helpB = newbutton(helpicon,"Help");
	manualB = newbutton(manualicon,"Manual");
	keyboardB = newbutton(keyboardicon,"Keyboard");
	aboutB = newbutton(abouticon,"About");
	noB = newbutton(noicon,"Nothing");
	smallB = newbutton(smallicon,"Small");
	mediumB = newbutton(mediumicon,"Medium");
	yescenterB = newbutton(centeryes,"PlaceCenter");
	nocenterB = newbutton(centerno,"RemoveCenter");
	nozoomB = newbutton(zoomno,"NoZoom");

	separator0.setMaximumSize(new Dimension(8,8));
     	separator0.setPreferredSize(new Dimension(8,8));
     	separator1.setMaximumSize(new Dimension(8,8));
     	separator1.setPreferredSize(new Dimension(8,8));
     	separator2.setMaximumSize(new Dimension(8,8));
     	separator2.setPreferredSize(new Dimension(8,8));
     	separator3.setMaximumSize(new Dimension(8,8));
     	separator3.setPreferredSize(new Dimension(8,8));
     	separator4.setMaximumSize(new Dimension(8,8));
     	separator4.setPreferredSize(new Dimension(8,8));
     	separator5.setMaximumSize(new Dimension(8,8));
     	separator5.setPreferredSize(new Dimension(8,8));
     	separator6.setMaximumSize(new Dimension(8,8));
     	separator6.setPreferredSize(new Dimension(8,8));
     	separator7.setMaximumSize(new Dimension(8,8));
     	separator7.setPreferredSize(new Dimension(8,8));
     	separator8.setMaximumSize(new Dimension(8,8));
     	separator8.setPreferredSize(new Dimension(8,8));

	toolBar.add(openB);toolBar.add(pasteB);toolBar.add(saveB);
	toolBar.add(viewB);
	toolBar.add(separator1);toolBar.add(deleteB);
	toolBar.add(clearB);toolBar.add(groupB);toolBar.add(group_allB);
	toolBar.add(ungroupB);toolBar.add(ungroup_allB);
	toolBar.add(select_allB);toolBar.add(cloneB);
	toolBar2.add(pointB);toolBar2.add(lineB);toolBar2.add(polylineB);
	toolBar2.add(angleB);toolBar2.add(bezierB);toolBar2.add(bsplineB);
	toolBar2.add(nurbB);toolBar2.add(spiralB);
	toolBar2.add(separator2);
	toolBar2.add(rectangleB);
	toolBar2.add(ellipseB);toolBar2.add(polygonB);
	toolBar2.add(circleB);
	toolBar2.add(polyregB);toolBar2.add(roundrectangleB);
	toolBar2.add(sectorB);toolBar2.add(arcoB);toolBar2.add(closebezierB);
	toolBar2.add(closesplineB);toolBar2.add(closednurbB);
	toolBar2.add(separator7);toolBar2.add(noB);toolBar2.add(smallB);
	toolBar2.add(mediumB);
	toolBar2.add(separator8);
	toolBar2.add(yescenterB);
	toolBar2.add(nocenterB);
	toolBar2.add(nozoomB);

	toolBar.add(separator3);
	toolBar.add(placeB);toolBar.add(scaleB);toolBar.add(fontB);
	toolBar.add(leftB);toolBar.add(centerB);toolBar.add(rightB);
	toolBar.add(separator4);
	toolBar.add(arrowsB);toolBar.add(colorB);toolBar.add(fillcolorB);
	toolBar.add(unfillB);toolBar.add(thicknessB);toolBar.add(strokeB);
	toolBar.add(separator5);
	toolBar.add(editorB);toolBar.add(metapostB);toolBar.add(imageB);
	toolBar.add(separator6);toolBar.add(manualB);toolBar.add(keyboardB);
	toolBar.add(helpB);toolBar.add(aboutB);
	toolBar.add(separator0);
	toolBar.add(exitB);
	toolBar.setRollover(true);
	toolBar.setVisible(TOOLBAR);
	toolBar2.setRollover(true);
	toolBar2.setVisible(TOOLBAR);
	getContentPane().add(toolBar, BorderLayout.NORTH);
	getContentPane().add(toolBar2, BorderLayout.WEST);
    }

    String myName;
    public void actionPerformed(ActionEvent evt){}

    public JButton newbutton(Icon miIcon, String memo)
    {
	final String miNom = memo;
	JButton button = new JButton(miIcon);
	button.setSize(16,16);
	button.setToolTipText(memo);
	//	if(memo=="Point" || memo=="Line" || memo=="Polyline" || memo=="Bezier" || memo=="Bspline" || memo=="Angle" || memo=="Rectangle" || memo=="Roundrectangle" || memo=="Ellipse" || memo=="Circle" || memo=="Polygon")
      	button.setBorder(borFin);
	//      button.setBorder(BorderFactory.createRaisedBevelBorder());

	button.addActionListener(new ActionListener() 
	    {
		public void actionPerformed(ActionEvent e)
		{
		    orden=miNom;
		    notifyObservers();
		}
	    });
	return button;
    }

    public void registerObserver(Observer o) {
	observers.add(o);
    }

    public void removeObserver(Observer o) {
	int i = observers.indexOf(o);
	if(i >= 0) observers.remove(i);
    }

    public void notifyObservers() {
	for(int i = 0; i<observers.size(); i++) {
	    Observer observer = (Observer)observers.get(i);
	    observer.update(orden);
	}
    }

    private JMenuItem addMenuItem(JMenu menu, Action action) {
	JMenuItem item = menu.add(action);
	KeyStroke keystroke=(KeyStroke)action.getValue(Action.ACCELERATOR_KEY);
	if(keystroke != null) item.setAccelerator(keystroke);
	return item;
    }
    
    Metagraf miMeta;
    private MyAction newa, open, exit, save, paste, view, delete, group, ungroup, group_all, ungroup_all, select_all, clone, point, line, rectangle, normalcircle, spiral, polyline, bezier, bspline,closbezier,closspline, closednurb, nurb, angle, roundrectangle, ellipse, points3, points4, points5, points6, points8, otherpts; 
    MyAction polygon, polyreg, sector, arco, place, font, scale, right, center, left, curved, no, verysmall, small, medium, big, myarrow, color, fillcolor, unfill, thickness, stroke, lincap, linjoin, editor, metapost, image, latex, dvips, size, manual, about, keyboard, contact, showTB,hideTB,portrait,landscape,yescenter,nocenter,nozoom,arrows,placeImag;
private JButton openB, pasteB, saveB, ungroup_allB, viewB, exitB, clearB,deleteB, groupB, ungroupB,group_allB,select_allB,cloneB,pointB,lineB,rectangleB,circleB,polylineB,bezierB,bsplineB,nurbB,angleB,roundrectangleB,ellipseB,polygonB,polyregB,placeB,scaleB,fontB,colorB,fillcolorB,unfillB,arrowsB,thicknessB,strokeB,editorB,metapostB,imageB,helpB,aboutB,spiralB,sectorB,arcoB,closebezierB,closesplineB,closednurbB,manualB,keyboardB,centerB,rightB,leftB,noB,smallB,mediumB,yescenterB,nocenterB,nozoomB;


    class MyAction extends AbstractAction 
    {

	static final long serialVersionUID = 603203089165094030L;

	MyAction(String name) {
	    super(name);
	    String iconFileName = "Images/"+name+".gif";
	    if(new File(iconFileName).exists())
		putValue(SMALL_ICON, new ImageIcon(iconFileName));
	}
	
	MyAction(String name, KeyStroke keystroke) {
	    this(name);
	    if(keystroke != null)
		putValue(ACCELERATOR_KEY, keystroke);
	}
	
	MyAction(String name, KeyStroke keystroke, String tooltip) {
	    this(name, keystroke);
	    if(tooltip != null)
		putValue(SHORT_DESCRIPTION, tooltip);
	}
	
	//Unica manera encontrada de obtener el valor de "name"

	public void actionPerformed(ActionEvent e) {
	    orden=e.getActionCommand();
	    notifyObservers();
	}
    }
}
