/**
 *
 * Simple demo to show JPedal being used as a simple GUI viewer.
 * 
 * represents the minimum needed to display a PDF page.
 * 
 */
//package org.jpedal.examples.jpaneldemo;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import org.jpedal.PdfDecoder;

public class JPanelDemo extends JInternalFrame {

    private String viewerTitle="Metagraf Viewer";
    private PdfDecoder pdfDecoder;
    private String currentFile="mgraf.pdf";
    private int currentPage=1;
    JInternalFrame miVisor = new JInternalFrame("Viewer",true,true,true,true);
    	public JPanelDemo(String name){
		
		pdfDecoder = new PdfDecoder();
		setTitle(viewerTitle);
		currentFile = name;
		if(currentFile!=null){
		try{
			//this opens the PDF and reads its internal details
			pdfDecoder.openPdfFile(currentFile);
			
			//these 2 lines opens page 1 at 100% scaling
			pdfDecoder.decodePage(currentPage);
			pdfDecoder.setPageParameters(0.75f,1); //values scaling (1=100%). page number
		}catch(Exception e){
			e.printStackTrace();
		}
		}
		//setup our GUI display
		initializeViewer();
		
		//set page number display
		//		pageCounter2.setText(currentPage+"");
		//		pageCounter3.setText("of "+pdfDecoder.getPageCount());
	}
    
	public JPanelDemo(){

	   	setTitle(viewerTitle);
	    //	    this.miVisor=miVisor;
		pdfDecoder = new PdfDecoder();

		try{
			//this opens the PDF and reads its internal details
			pdfDecoder.openPdfFile(currentFile);
			
			//these 2 lines opens page 1 at 100% scaling
			pdfDecoder.decodePage(currentPage);
			pdfDecoder.setPageParameters(0.75f,1); //values scaling (1=100%). page number
		}catch(Exception e){
			e.printStackTrace();
		}

		initializeViewer();
		
	}

    public void view() {
		try{
			//this opens the PDF and reads its internal details
			pdfDecoder.openPdfFile(currentFile);
			
			//these 2 lines opens page 1 at 100% scaling
			pdfDecoder.decodePage(currentPage);
			pdfDecoder.setPageParameters(0.75f,1); //values scaling (1=100%). page number
		}
		catch(Exception e){e.printStackTrace();}
		repaint();
    }

	private void initializeViewer() {
	    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	    setResizable(true);
	    setMaximizable(true);
	    setIconifiable(true);
	    Container cPane = getContentPane();
	    //	    Container cPane = new JInternalFrame(viewerTitle,true,true,true,true);
			    //  Container cPane = miVisor;
	    cPane.setLayout(new BorderLayout());
		JScrollPane display = initPDFDisplay();
		cPane.add(display,BorderLayout.CENTER);
		pack();
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		//		setMaximumSize(new Dimension(screen.width/4,6*screen.height/7));

		//		setMinimumSize(new Dimension(screen.width/20,6*screen.height/70));
		setSize(new Dimension(screen.width/4,6*screen.height/7));

		//setLocationRelativeTo(null);//centre on screen
		setVisible(true);
	}
 
	private JScrollPane initPDFDisplay() {
		
		JScrollPane currentScroll = new JScrollPane();
		currentScroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		currentScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		
		currentScroll.setViewportView(pdfDecoder);
        
		return currentScroll;
	}
    /*
	public static void main(String[] args) {
		
		JPanelDemo current;
        
        if (args.length > 0) {
            current = new JPanelDemo(args[0]);
        } 
	else current = new JPanelDemo();
 	}
*/
}
